config/routes.rb
Rails.application.routes.draw do
  devise_for :users, skip: [:passwords]
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  resources :uploads, except: [:update, :edit, :destroy]

  root to: 'home#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/client.rb
class Client < ApplicationRecord
  has_many :sales
end

app/models/item.rb
class Item < ApplicationRecord
  monetize :price_cents

  has_many :item_sales
  belongs_to :merchant
end

app/models/item_sale.rb
class ItemSale < ApplicationRecord
  monetize :price_cents

  belongs_to :item
  belongs_to :sale
end

app/models/merchant.rb
class Merchant < ApplicationRecord
  has_many :sales
  has_many :items
end

app/models/sale.rb
class Sale < ApplicationRecord
  has_many :item_sales
  has_many :items, through: :item_sales

  belongs_to :client
  belongs_to :upload
end

app/models/upload.rb
class Upload < ApplicationRecord
  mount_uploader :file, FileUploader

  has_many :sales
  belongs_to :user


  # Usually I would use a decorator, but because this a test, I will just make the calc

  def total_gross
    total = Money.new(0)
    sales.each do |sale|
      values = sale.item_sales.map do |item_sale|
        item_sale.price * item_sale.quantity
      end
      total += values.sum
    end
    total
  end
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :trackable

  has_many :uploads
  has_many :sales, through: :uploads
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :authenticate_user!
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
    @last_uploads = current_user.uploads.order('created_at DESC').limit(5)
  end
end

app/controllers/uploads_controller.rb
require 'sales_parser/service'

class UploadsController < ApplicationController
  def index
    @uploads = current_user.uploads
  end

  def new
    @upload = Upload.new
  end

  def create
    begin
      @upload = Upload.create(upload_params.merge(user: current_user))
      @service = SalesParser::Service.new(upload: @upload)
      @service.parse_sales

      redirect_to @upload
    rescue ArgumentError => e
      @upload.delete
      flash[:alert] = 'Error during importing sales, please check the file'
      render :new
    end
  end

  def show
    @upload = Upload.find(params[:id])
    @sales = @upload.sales.includes(:client, item_sales: [:item])
  end

  private

  def upload_params
    params.require(:upload).permit(:description, :file)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/flash_helper.rb
module FlashHelper
  def render_flash_messages
    return unless flash.any?
    [:notice, :alert].map { |type| render_alert(type) }.join.html_safe
  end

  private

  def render_alert(type)
    return unless flash[type]
    klass = find_alert_klass(type)

    content_tag(:div, class: "alert alert-#{klass}", role: 'alert') do
      content_tag(:span, flash[type])
    end
  end

  def find_alert_klass(type)
    case type
    when :notice then :success
    when :alert then :warning
    else type
    end
  end
end

app/views/home/index.html.haml
.page-header
  .row
    .col-8
      %h1 Welcome #{current_user.name}!
    .col-4.text-right
      = button_to destroy_user_session_path, class: 'btn btn-dark', method: :delete do
        %i Sign out
  %hr

.row
  .col-6
    = link_to "Upload new file", new_upload_path, class: 'btn btn-primary'

    .card.mt-3
      .card-header
        Your last imports
      %ul.list-group.list-group-flush
        - @last_uploads.each do |upload|
          %li.list-group-item
            = link_to upload_path(upload) do
              %b= "#{upload.description}:"
              %span= I18n.l upload.created_at

app/views/layouts/application.html.haml
!!!
%html
  %head
    %meta(content="text/html; charset=UTF-8" http-equiv="Content-Type")
    %meta(name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no")
    %meta(charset="utf-8")
    %title Nuuvem
    = csrf_meta_tags
    = csp_meta_tag

    = stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload'
    = javascript_include_tag 'application', 'data-turbolinks-track': 'reload'
  %body
    .container
      #flash-messages-container
        = render_flash_messages
      = yield

app/views/uploads/index.html.haml
.row
  .col-8
    %h1 List uploads
  .col-4.h1.text-right
    = link_to 'Upload new file', new_upload_path, class: 'btn btn-info'
%hr

.row
  .col-12
    %table.table.table-hover
      %thead
        %tr
          %th Description
          %th Created at
      %tbody
        - @uploads.each do |upload|
          %tr
            %td= link_to upload.description, upload_path(upload)
            %td= I18n.l(upload.created_at)
  .col-12.pt-3
    = link_to 'Back to home', root_path, class: 'btn btn-light'

app/views/uploads/new.html.haml
.page-header
  %h1 New upload!
  %hr

.row
  .col-12
    = form_for @upload do |f|
      .form-group
        = f.label :description
        = f.text_field :description, class: 'form-control'
      .form-group
        = f.label :file
        = f.file_field :file, class: 'form-control'
      %hr
      = f.button type: 'submit', class: 'btn btn-success float-right' do
        Salvar
      = link_to 'Cancel', uploads_path, class: 'btn btn-light'

app/views/uploads/show.html.haml
%h1= "Upload: #{@upload.description}"
%hr

.row
  .col-12
    %h3 Sales
    %table.table.table-hover
      %thead
        %tr
          %th Client
          %th Item
          %th Quantity
          %th Price
      %tbody
        - @sales.find_each do |sale|
          - sale.item_sales.each do |item_sale|
            %tr
              %td= sale.client.name
              %td= item_sale.item.description
              %td= item_sale.quantity
              %td= item_sale.price
        %tr
          %td{ colspan: 2 }
          %td Total gross
          %td= @upload.total_gross
  .col-12.pt-3
    = link_to 'Show all uploads', uploads_path, class: 'btn btn-light'